module led (clk_in, 
		  	clk_out
			);
			
	input 		clk_in;
	output 		[7:0]clk_out;
	reg			[7:0]clk_out;

	parameter		DIV_COUNT = 10_000_000; 
					// fact is para * 2

	integer			count;
	
	always@(posedge clk_in) 
	begin
		if( count == DIV_COUNT )
		  begin
			clk_out = ~clk_out;
			count = 0;
		  end
		else
			count = count + 1;  
	
	end
endmodule
