/*-----Ȩ-----
 *     ׵ӹҡÿø 
 *     վhttp://www.amy-studio.com
 *     Աhttp://amy-studio.taobao.com
 *     QQ䣩amy-studio@qq.com
 *-----ļϢ-----
 *     ļƣkey_debounce.v
 *     ޸ڣ2.4, 2010
 *     KEY x 4
 *------------------
 *     ߣǷ
 *     ڣ2.4, 2010
 *     汾1.0
 *     ԭʼ汾
 *------------------
 *     ޸ߣ
 *     ޸ڣ
 *     汾
 *     
 *-------------------
 */

module key_debounce(
  input            i_clk,
  input            i_rst_n,
  input      [4:1] i_key,               // Ϊ0ɿΪ1
  output reg [4:1] o_key_val            // ֵ
);  

//++++++++++++++++++++++++++++++++++++++
reg [4:1] key_samp1, key_samp1_locked;

// i_keyɼkey_samp1
always @ (posedge i_clk, negedge i_rst_n)
  if(!i_rst_n) 
    key_samp1 <= 4'hF;
  else         
    key_samp1 <= i_key;

// key_samp1key_samp1_locked
always @ (posedge i_clk, negedge i_rst_n)
  if(!i_rst_n) 
    key_samp1_locked <= 4'hF;
  else         
    key_samp1_locked <= key_samp1;
//--------------------------------------

//++++++++++++++++++++++++++++++++++++++
wire [4:1] key_changed1;

// key_samp11Ϊ0ʱ
// key_changed10Ϊ1ֻάһʱ
assign key_changed1 = key_samp1_locked & (~key_samp1); 
//--------------------------------------


//++++++++++++++++++++++++++++++++++++++
reg [19:0] cnt;

// һа£cnt
always @ (posedge i_clk, negedge i_rst_n)
  if(!i_rst_n)
    cnt <= 20'h0;
  else if(key_changed1)
    cnt <= 20'h0;
  else
    cnt <= cnt + 1'b1;
//--------------------------------------


//++++++++++++++++++++++++++++++++++++++
reg [4:1] key_samp2, key_samp2_locked;

// ֻе仯ά20msʱ
// Ži_keyɼkey_samp2
always @ (posedge i_clk, negedge i_rst_n)
  if(!i_rst_n)
    key_samp2 <= 4'hF;
  else if(cnt == 20'hF_FFFF)            // 0xFFFFF/50M = 20.9715ms
    key_samp2 <= i_key;

// key_samp2key_samp2_locked
always @ (posedge i_clk, negedge i_rst_n)
  if(!i_rst_n)
    key_samp2_locked <= 4'hF;
  else
    key_samp2_locked <= key_samp2;
//--------------------------------------

//++++++++++++++++++++++++++++++++++++++
wire [4:1] key_changed2;

// key_samp21Ϊ0ʱ
// key_changed20Ϊ1ֻάһʱ
assign key_changed2 = key_samp2_locked & (~key_samp2); 
//--------------------------------------


//++++++++++++++++++++++++++++++++++++++
// ÿΰȶֵ
// Ϊ0ɿΪ1
always @ (posedge i_clk, negedge i_rst_n)
  if(!i_rst_n)
    o_key_val <= 4'hF;
  else
    o_key_val <= ~key_changed2;
//--------------------------------------

endmodule 
