/*-----Ȩ-----
 *     ׵ӹҡÿø 
 *     վhttp://www.amy-studio.com
 *     Աhttp://amy-studio.taobao.com
 *     QQ䣩amy-studio@qq.com
 *-----ļϢ-----
 *     ļƣuart_tx_test.v
 *     ޸ڣ3.9, 2010
 *     UARTղļ
 *------------------
 *     ߣǷ
 *     ڣ3.9, 2009
 *     汾1.0
 *     UARTģȨfpga4fun.com
 *------------------
 *     ޸ߣ
 *     ޸ڣ
 *     汾
 *     
 *-------------------
 */
module uart_rx_test(
  input        CLOCK_50,
  input        Q_KEY,
  // UART Interface
  input        UART_RXD,
  // LCD1602 Interface
  output [7:0] LCD1602_DATA,            // LCD1602                
  output       LCD1602_E,               // LCD1602ʹ
  output       LCD1602_RS,              // LCD1602ָѡ
  output       LCD1602_RW               // LCD1602дѡ
);

//++++++++++++++++++++++++++++++++++++++
// UART ʼ
//++++++++++++++++++++++++++++++++++++++
wire [7:0] RxD_data;
wire RxD_data_ready;                    // RxD_dataЧʱģһʱ

// ʣ9600
// λ8
// żλ
// ֹͣλ1
uart_rx uart_u0(
  .clk              (CLOCK_50),
  .RxD              (UART_RXD),
  .RxD_data_ready   (RxD_data_ready),
  .RxD_data         (RxD_data),
  .RxD_endofpacket  (),
  .RxD_idle         ()
);
//--------------------------------------
// UART 
//--------------------------------------


//++++++++++++++++++++++++++++++++++++++
//  LCD1602ʾ ʼ
//++++++++++++++++++++++++++++++++++++++
// 0 ~ (8*16-1) = 128
reg [127:0] row1_val;                   // LCD1602 1ַ
reg [127:0] row2_val;                   // LCD1602 2ַ 

always @ (posedge CLOCK_50, negedge Q_KEY)
  if (!Q_KEY)
  begin
    // 16bits-> 0123456789ABCDEF <-
    row1_val = "UART rcved is   ";
    row2_val = "Amy-studio Pub  ";
  end
  else
  begin
    if (RxD_data_ready)
      row1_val[7:0] <= RxD_data;
  end

// LCD1602
lcd1602_drive lcd_1602_u0(
  .clk              (CLOCK_50),
  .rst_n            (Q_KEY),
  // LCD1602 Input Value
  .row1_val         (row1_val),
  .row2_val         (row2_val),
  // LCD1602 Interface
  .lcd_data         (LCD1602_DATA),
  .lcd_e            (LCD1602_E),
  .lcd_rs           (LCD1602_RS),
  .lcd_rw           (LCD1602_RW)
);
//--------------------------------------
//  LCD1602ʾ 
//--------------------------------------


endmodule
